VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Form1"
   ClientHeight    =   5685
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   7230
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5685
   ScaleWidth      =   7230
   StartUpPosition =   3  'Windows Default
   Begin MSComDlg.CommonDialog cmdDialog 
      Left            =   2115
      Top             =   5085
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      DialogTitle     =   "Browse"
   End
   Begin VB.CommandButton btnCancel 
      Caption         =   "Cancel"
      Height          =   375
      Left            =   5880
      TabIndex        =   17
      Top             =   5040
      Width           =   1095
   End
   Begin VB.CommandButton btnStartPrinting 
      Caption         =   "Start Printing"
      Height          =   375
      Left            =   4680
      TabIndex        =   16
      Top             =   5040
      Width           =   1095
   End
   Begin VB.Frame Frame4 
      Caption         =   "File to convert"
      Height          =   855
      Left            =   240
      TabIndex        =   15
      Top             =   3960
      Width           =   6735
      Begin VB.CommandButton btnBrowse 
         Caption         =   "Browse"
         Height          =   375
         Left            =   5640
         TabIndex        =   19
         Top             =   315
         Width           =   855
      End
      Begin VB.TextBox txtFileToConvert 
         Height          =   285
         Left            =   120
         TabIndex        =   18
         Top             =   360
         Width           =   5295
      End
   End
   Begin VB.Frame Frame3 
      Caption         =   "PDF Name"
      Height          =   855
      Left            =   240
      TabIndex        =   11
      Top             =   2880
      Width           =   6735
      Begin VB.CheckBox chkOpenViewer 
         Caption         =   "Open Viewer"
         Height          =   255
         Left            =   5280
         TabIndex        =   14
         Top             =   360
         Width           =   1215
      End
      Begin VB.TextBox txtFilename 
         Height          =   285
         Left            =   1080
         TabIndex        =   13
         Top             =   360
         Width           =   3975
      End
      Begin VB.Label Label4 
         Caption         =   "File Name:"
         Height          =   255
         Left            =   120
         TabIndex        =   12
         Top             =   360
         Width           =   855
      End
   End
   Begin VB.Frame Frame2 
      Caption         =   "Doc Info"
      Height          =   1695
      Left            =   2160
      TabIndex        =   6
      Top             =   960
      Width           =   4815
      Begin VB.TextBox txtSubject 
         Height          =   285
         Left            =   840
         TabIndex        =   10
         Top             =   1080
         Width           =   3735
      End
      Begin VB.TextBox txtTitle 
         Height          =   285
         Left            =   840
         TabIndex        =   8
         Top             =   480
         Width           =   3735
      End
      Begin VB.Label Label3 
         Caption         =   "Subject:"
         Height          =   255
         Left            =   120
         TabIndex        =   9
         Top             =   1080
         Width           =   615
      End
      Begin VB.Label Label2 
         Caption         =   "Title:"
         Height          =   375
         Left            =   120
         TabIndex        =   7
         Top             =   480
         Width           =   615
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "Options"
      Height          =   1695
      Left            =   240
      TabIndex        =   2
      Top             =   960
      Width           =   1695
      Begin VB.CheckBox chkDetectLinks 
         Caption         =   "Detect Links"
         Height          =   255
         Left            =   240
         TabIndex        =   5
         Top             =   1200
         Width           =   1335
      End
      Begin VB.CheckBox chkEmbedFonts 
         Caption         =   "Embed Fonts"
         Height          =   255
         Left            =   240
         TabIndex        =   4
         Top             =   840
         Width           =   1335
      End
      Begin VB.CheckBox chkCompress 
         Caption         =   "Compress"
         Height          =   255
         Left            =   240
         TabIndex        =   3
         Top             =   480
         Width           =   1335
      End
   End
   Begin VB.ComboBox cmbProfiles 
      Height          =   315
      Left            =   240
      TabIndex        =   0
      Top             =   360
      Width           =   2295
   End
   Begin VB.Label Label1 
      Caption         =   "Select Profile:"
      Height          =   375
      Left            =   240
      TabIndex        =   1
      Top             =   120
      Width           =   1935
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
 
Const PRINTER_NAME As String = "novaPDF SDK 9"
Const SMALL_SIZE_PROFILE As String = "Small Size Profile"
Const FULL_OPT_PROFILE As String = "Full Options Profile"
Const PROFILE_IS_PUBLIC As Long = 0
Const NV_PROFILE_EXISTS As Long = -707133434

Dim strInitDir As String
Dim cmbProfilesData(10)

Private Sub UpdateProfileFromDialog()
    
    On Error GoTo ErrorHandler:
    Dim strProfileID As String
    strProfileID = cmbProfilesData(cmbProfiles.ListIndex)
    'load selected profile
    m_NovaOptions.LoadProfile2 strProfileID
    'set options in profile
    m_NovaOptions.SetOptionBool NOVAPDF_COMPRESS_TEXT_GRAPHICS, CBool(chkCompress.value)
    m_NovaOptions.SetOptionBool NOVAPDF_URL_ANALIZE, CBool(chkDetectLinks.value)
    m_NovaOptions.SetOptionBool NOVAPDF_FONTS_EMBED_ALL_USED_FONTS, CBool(chkDetectLinks.value)
    m_NovaOptions.SetOptionString2 NOVAPDF_SAVE_FILE_NAME, txtFilename
    m_NovaOptions.SetOptionString2 NOVAPDF_DOCINFO_SUBJECT, txtSubject
    m_NovaOptions.SetOptionString2 NOVAPDF_DOCINFO_TITLE, txtTitle
    'save profile changes
    m_NovaOptions.SaveProfile
    Exit Sub
ErrorHandler:
    Debug.Print (err.Number & ":" & err.Description)
End Sub
Private Sub UpdateDialogFromProfile()
    On Error Resume Next
    Dim strProfileID As String
    Dim bvalue As Long
    
    strProfileID = cmbProfilesData(cmbProfiles.ListIndex)
    'load selected profile
    m_NovaOptions.LoadProfile2 strProfileID
    'get options fom profile
    m_NovaOptions.GetOptionBool NOVAPDF_COMPRESS_TEXT_GRAPHICS, bvalue
    ToggleState chkCompress, bvalue, err.Number
    err.Clear
    m_NovaOptions.GetOptionBool NOVAPDF_URL_ANALIZE, bvalue
    ToggleState chkDetectLinks, bvalue, err.Number
    err.Clear
    m_NovaOptions.GetOptionBool NOVAPDF_FONTS_EMBED_ALL_USED_FONTS, bvalue
    ToggleState chkEmbedFonts, bvalue, err.Number
    err.Clear
 
    Dim strValue As String
    m_NovaOptions.GetOptionString2 NOVAPDF_SAVE_FILE_NAME, strValue
    If err.Number = 0 Then txtFilename.Text = strValue
    err.Clear

    m_NovaOptions.GetOptionString2 NOVAPDF_DOCINFO_SUBJECT, strValue
    If err.Number = 0 Then txtSubject.Text = strValue
    err.Clear

    m_NovaOptions.GetOptionString2 NOVAPDF_DOCINFO_TITLE, strValue
    If err.Number = 0 Then txtTitle.Text = strValue
    err.Clear

End Sub


Private Sub ToggleState(ByVal chkBox As CheckBox, ByVal value As Long, ByVal err As Long)
    If err <> 0 Then
        chkBox.value = 0
    End If
    If value <> 0 Then
        chkBox.value = 1
    Else
        chkBox.value = 0
    End If
End Sub

Private Sub btnBrowse_Click()
    If cmdDialog.InitDir = "" Then cmdDialog.InitDir = "C:\"
    cmdDialog.ShowOpen
    txtFileToConvert.Text = cmdDialog.FileName
End Sub


Private Sub btnCancel_Click()
    Unload Form1
End Sub

Private Sub btnStartPrinting_Click()
    On Error GoTo ErrorHandler
    btnStartPrinting.Enabled = False

    UpdateProfileFromDialog
    If Trim(txtFileToConvert) = "" Then
        MsgBox ("No file to convert!")
        btnStartPrinting.Enabled = True
        Exit Sub
    End If

    Dim strProfileID As String
    strProfileID = cmbProfilesData(cmbProfiles.ListIndex)
    m_NovaOptions.SetActiveProfile2 strProfileID
    m_NovaOptions.SetDefaultPrinter
    Dim strToExecute As String
    Dim r As Long
    m_NovaOptions.RegisterEventWindow Me.hwnd
    m_NovaOptions.LicenseShellExecuteFile txtFileToConvert
    r = ShellExecute(Me.hwnd, "print", txtFileToConvert, "", "", SW_HIDE)
    btnStartPrinting.Enabled = True
    Exit Sub
ErrorHandler:
    Debug.Print (err.Number & ":" & err.Description)
    btnStartPrinting.Enabled = True
End Sub

Private Sub cmbProfiles_Click()
    UpdateDialogFromProfile
End Sub

Private Sub Form_Load()

    On Error GoTo ErrorHandler
    Dim strProfileID As String
    Dim strProfileName As String
    Dim strActiveProfileID As String
    Dim nPublicProfile As Long
    Dim nActivePublicProfile As Long

    ' initialize the NovaPdfOptions object to use with a printer licensed for SDK
    m_NovaOptions.Initialize2 PRINTER_NAME, ""

    ' sets the value of the windows messages handler to VB_WindowProc and sets the old handler address of function in oldHandler
    oldHandler = SetWindowLongApi(Me.hwnd, GWL_WNDPROC, AddressOf VB_WindowProc)

    cmbProfiles.Clear

    Call AddSmallSize
    Call AddFullOptions

    On Error Resume Next
    ' get the active profile ...
    m_NovaOptions.GetActiveProfile2 strActiveProfileID

    'fill profiles combo
    Dim nIndex As Long
    nIndex = 0
    On Error GoTo ErrorHandler
    m_NovaOptions.GetFirstProfile2 strProfileID
    m_NovaOptions.LoadProfile2 strProfileID
    m_NovaOptions.GetOptionString2 NOVAPDF_PROFILE_NAME, strProfileName
    cmbProfiles.AddItem (strProfileName)
    cmbProfilesData(nIndex) = strProfileID
    nIndex = nIndex + 1

    On Error Resume Next
    Do
        m_NovaOptions.GetNextProfile2 strProfileID
        If err.Number = NV_NO_MORE_PROFILES Then
            Exit Do
        End If
        m_NovaOptions.LoadProfile2 strProfileID
        m_NovaOptions.GetOptionString2 NOVAPDF_PROFILE_NAME, strProfileName
        cmbProfiles.AddItem (strProfileName)
        cmbProfilesData(nIndex) = strProfileID
        nIndex = nIndex + 1
    Loop While True

    On Error GoTo ErrorHandler

    cmbProfiles.ListIndex = 0

    UpdateDialogFromProfile
    Exit Sub
ErrorHandler:
    Debug.Print (err.Number & ":" & err.Description)
End Sub

Private Sub AddSmallSize()
    Dim strProfileID As String
    On Error GoTo ErrHandler

    m_NovaOptions.AddProfile2 SMALL_SIZE_PROFILE, PROFILE_IS_PUBLIC, strProfileID
    m_NovaOptions.LoadProfile2 strProfileID

    ' Set some options to this profile

    ' disable the "Save PDF file as" prompt
    m_NovaOptions.SetOptionLong NOVAPDF_SAVE_PROMPT_TYPE, PROMPT_SAVE_NONE
    ' set generated Pdf files destination folder  "c:\"
    m_NovaOptions.SetOptionString2 NOVAPDF_SAVE_FOLDER, "c:\"
    ' set output file name
    m_NovaOptions.SetOptionString2 NOVAPDF_SAVE_FILE_NAME, "PDF Converter small size.pdf"
    ' if file exists in the destination folder, append a counter to the end of the file name
    m_NovaOptions.SetOptionLong NOVAPDF_SAVE_FILEEXIST_ACTION, FILE_CONFLICT_STRATEGY_AUTONUMBER_NEW
    ' don't detect URLs
    m_NovaOptions.SetOptionBool NOVAPDF_URL_ANALIZE, False

    ' Set image compresion method to JPEG and quality to 75, possible values are from 10 to 100
    m_NovaOptions.SetOptionBool NOVAPDF_COMPRESS_ENABLE, True
    m_NovaOptions.SetOptionBool NOVAPDF_COMPRESS_HIGH_COLOR, True
    m_NovaOptions.SetOptionLong NOVAPDF_COMPRESS_HIGH_COLOR_TYPE, COMPRESS_METHOD_JPEG
    m_NovaOptions.SetOptionLong NOVAPDF_COMPRESS_HIGH_COLOR_LEVEL, 75

    ' make sure text compression is enabled, and set compression level to 9  maximum   posible values are 1-9
    m_NovaOptions.SetOptionBool NOVAPDF_COMPRESS_TEXT_GRAPHICS, True
    m_NovaOptions.SetOptionLong NOVAPDF_COMPRESS_TEXT_GRAPHICS_LEVEL, 9

    ' disable unused font embeding
    m_NovaOptions.SetOptionBool NOVAPDF_FONTS_EMBED_ALL_USED_FONTS, False

    'save profile changes
    m_NovaOptions.SaveProfile

    Exit Sub
ErrHandler:
    If err.Number <> NV_PROFILE_EXISTS Then Debug.Print (err.Number & ":" & err.Description)

End Sub


Private Sub AddFullOptions()
    Dim strProfileID As String
    On Error GoTo ErrHandler

    ' Add the profile "Full options", and edit its options
    m_NovaOptions.AddProfile2 FULL_OPT_PROFILE, PROFILE_IS_PUBLIC, strProfileID
    m_NovaOptions.LoadProfile2 strProfileID

    ' disable the "Save PDF file as" prompt
    m_NovaOptions.SetOptionLong NOVAPDF_SAVE_PROMPT_TYPE, PROMPT_SAVE_NONE
    ' set generated Pdf files destination folder  "c:\"
    m_NovaOptions.SetOptionString2 NOVAPDF_SAVE_FOLDER, "c:\"
    ' set output file name "[N] full", the [N] macro means document name
    m_NovaOptions.SetOptionString2 NOVAPDF_SAVE_FILE_NAME, "[N] full"
    ' if file exists in the destination folder, append a counter to the end of the file name
    m_NovaOptions.SetOptionLong NOVAPDF_SAVE_FILEEXIST_ACTION, FILE_CONFLICT_STRATEGY_AUTONUMBER_NEW
    ' enable URL detection
    m_NovaOptions.SetOptionBool NOVAPDF_URL_ANALIZE, True

    ' set image JPEG quality to 100  maximum
    m_NovaOptions.SetOptionBool NOVAPDF_COMPRESS_ENABLE, True
    m_NovaOptions.SetOptionBool NOVAPDF_COMPRESS_HIGH_COLOR, True
    m_NovaOptions.SetOptionLong NOVAPDF_COMPRESS_HIGH_COLOR_TYPE, COMPRESS_METHOD_JPEG
    m_NovaOptions.SetOptionLong NOVAPDF_COMPRESS_HIGH_COLOR_LEVEL, 100

    ' set text compression to 6  on the "zip" scale from 0 to 9
    m_NovaOptions.SetOptionBool NOVAPDF_COMPRESS_TEXT_GRAPHICS, True
    m_NovaOptions.SetOptionLong NOVAPDF_COMPRESS_TEXT_GRAPHICS_LEVEL, 6
    ' enable font files embedding
    m_NovaOptions.SetOptionBool NOVAPDF_FONTS_EMBED_ALL_USED_FONTS, True

    'save profile changes
    m_NovaOptions.SaveProfile

    Exit Sub
ErrHandler:
    If err.Number <> NV_PROFILE_EXISTS Then Debug.Print (err.Number & ":" & err.Description)
End Sub

